<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="售后编号" prop="aftersaleSn">
        <el-input v-model="queryParams.aftersaleSn" placeholder="请输入售后编号" clearable @keyup.enter.native="handleQuery" style="width: 180px"/>
      </el-form-item>
      <el-form-item label="订单编号" prop="orderId">
        <el-input v-model="queryParams.orderId" placeholder="请输入订单编号" clearable @keyup.enter.native="handleQuery" style="width: 160px"/>
      </el-form-item>
      <el-form-item label="用户姓名" prop="cusName">
        <el-input v-model="queryParams.cusName" placeholder="请输入用户姓名" clearable @keyup.enter.native="handleQuery" style="width: 148px"/>
      </el-form-item>
      <!-- <el-form-item label="退款原因" prop="reason">
        <el-input v-model="queryParams.reason" placeholder="请输入退款原因" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>-->
      <el-form-item label="联系电话" prop="mobile">
        <el-input v-model="queryParams.mobile" placeholder="请输入联系电话" clearable @keyup.enter.native="handleQuery"  style="width: 148px"/>
      </el-form-item> 
      <el-form-item label="售后时间" prop="createTimeList">
        <el-date-picker v-model="createTimeList" type="datetimerange" align="right" :picker-options="pickerOptions"
          style="width: 260px" start-placeholder="开始日期" end-placeholder="结束日期" format="yyyy-MM-dd"
          value-format="yyyy-MM-dd" @change="dateChangebirthday1">
        </el-date-picker>
      </el-form-item>
      <!-- <el-form-item label="操作时间" prop="handleTime">
        <el-date-picker clearable v-model="queryParams.handleTime" type="date" value-format="yyyy-MM-dd"
          placeholder="请选择管理员操作时间">
        </el-date-picker>
      </el-form-item> -->
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['mall:aftersale:add']"
          >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['mall:aftersale:edit']"
          >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['mall:aftersale:remove']"
          >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['mall:aftersale:export']"
          >导出
        </el-button>
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row> -->

    <el-table border v-loading="loading" :data="aftersaleList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="ID" align="center" prop="id" /> -->
      <el-table-column label="售后编号" align="center" prop="aftersaleSn" />
      <el-table-column label="订单编号" align="center" prop="orderId" />
      <el-table-column label="用户姓名" align="center" prop="cusName" />
      <el-table-column label="联系电话" align="center" prop="mobile" />
      <!-- <el-table-column label="售后类型" align="center" prop="type" /> -->
      <!-- <el-table-column label="退款原因" align="center" prop="reason" /> -->
      <el-table-column label="退款金额" align="center" prop="amount" />
      <!-- <el-table-column
        label="退款凭证图片"
        align="center"
        prop="pictures"
      /> -->
      <!-- <el-table-column label="退款说明" align="center" prop="comment" /> -->
      <el-table-column label="售后状态" align="center" prop="status">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.app_aftersale_status" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column label="售后时间" align="center" prop="handleTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.handleTime, "{y}-{m}-{d}") }}</span>
        </template>
      </el-table-column>
      <el-table-column fixed="right" label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="small" type="success"  @click="handleUpdate(scope.row)" v-hasPermi="['mall:aftersale:edit']" v-if="scope.row.status==1">通过
          </el-button>
          <el-button size="small" type="danger"  @click="handleDelete(scope.row)" v-hasPermi="['mall:aftersale:remove']" v-if="scope.row.status==1">拒绝
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <div class="pag">
      <div class="pag1">
        <pagination
          v-show="total > 0"
          :total="total"
          :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />
      </div>
    </div>

    <!-- 添加或修改售后对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="1300px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px" :inline="true">
        <el-form-item label="售后编号" prop="aftersaleSn">
          <el-input v-model="form.aftersaleSn" placeholder="请输入售后编号" />
        </el-form-item>
        <el-form-item label="订单编码" prop="orderId">
          <el-input v-model="form.orderId" placeholder="请输入订单编码" />
        </el-form-item>
        <el-form-item label="用户编码" prop="userId">
          <el-input v-model="form.userId" placeholder="请输入用户编码" />
        </el-form-item>
        <!-- <el-form-item label="退款原因" prop="reason">
          <el-input v-model="form.reason" placeholder="请输入退款原因" />
        </el-form-item> -->
        <el-form-item label="退款金额" prop="amount">
          <el-input v-model="form.amount" placeholder="请输入退款金额" />
        </el-form-item>
        <!-- <el-form-item label="退款凭证图片链接数组" prop="pictures">
          <el-input
            v-model="form.pictures"
            type="textarea"
            placeholder="请输入内容"
          />
        </el-form-item> -->
        <!-- <el-form-item label="退款说明" prop="comment">
          <el-input
            v-model="form.comment"
            type="textarea"
            placeholder="请输入内容"
          />
        </el-form-item> -->
        <el-form-item label="操作时间" prop="handleTime">
          <el-date-picker clearable v-model="form.handleTime" type="date" value-format="yyyy-MM-dd"
            placeholder="请选择管理员操作时间">
          </el-date-picker>
        </el-form-item>
      </el-form>
      <!-- <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div> -->
    </el-dialog>
  </div>
</template>

<script>
import {
  listAftersale,
  getAftersale,
  agreeToRefund,
  saleRefund,
  delAftersale,
  addAftersale,
  updateAftersale,
} from "@/api/mall/aftersale";

export default {
  name: "Aftersale",
  dicts: ['app_aftersale_status', ],

  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 售后表格数据
      aftersaleList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        aftersaleSn: null,
        orderId: null,
        userId: null,
        type: null,
        reason: null,
        amount: null,
        pictures: null,
        comment: null,
        status: null,
        handleTime: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      createTimeList: [],
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date(new Date().setHours(0, 0, 0, 0));
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date(new Date().setHours(0, 0, 0, 0));
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date(new Date().setHours(0, 0, 0, 0));
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
    };
  },
  created() {
    this.getNowTime()
    this.getList();
  },
  methods: {
      // / 处理默认选中当前日期
      getNowTime() {
      var curDate = new Date().getTime();
      var dayNum = 7 * 24 * 3600 * 1000;
      var threeDays = curDate - dayNum;
      var sDay = this.getLocalTime(threeDays);
      var end = this.getLocalTime(curDate);
      this.createTimeList = [sDay, end];
    },
    add0(m) {
      return m < 10 ? "0" + m : m;
    },
    getLocalTime(nS) {
      var time = new Date(nS);
      var y = time.getFullYear();
      var m = time.getMonth() + 1;
      var d = time.getDate();
      // var h = time.getHours();
      // var mm = time.getMinutes();
      return (
        y +
        "-" +
        this.add0(m) +
        "-" +
        this.add0(d)
      );
    },
    dateChangebirthday1(val) {
      if(val == null){
        this.createTimeList = []
      }else{
        this.createTimeList = val;
      }
    },
    /** 查询售后列表 */
    getList() {
      this.loading = true;
      if (this.createTimeList) {
        this.queryParams.startTime = this.createTimeList[0]
        this.queryParams.endTime = this.createTimeList[1]
      }
      listAftersale(this.queryParams).then((response) => {
        this.aftersaleList = response.rows;
      
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        aftersaleSn: null,
        orderId: null,
        userId: null,
        type: null,
        reason: null,
        amount: null,
        pictures: null,
        comment: null,
        status: 0,
        handleTime: null,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null,
        deleted: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.createTimeList = [];
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加售后";
    },
    /** 通过按钮操作 */
    handleUpdate(row) {
      let data = {
        actualPrice: row.amount,
        id: row.orderId,
        orderPrice: row.amount,
        refundAmount: row.amount,
        refundType: 1,
      }
      agreeToRefund(data).then(res => {
        if (res.code == 200) {
          this.$modal.msgSuccess("退款成功");
          this.getList()
        }
      })
    },
    handleDelete(row) {
      let data = {
        id: row.id,
      }
      saleRefund(data).then(res => {
        if (res.code == 200) {
          this.$modal.msgSuccess("已拒绝");
          this.getList()
        }
      })
    },
  },
};
</script>
<style scoped>
.pag {
  width: 100%;
  display: flex;
  justify-content: center;
}
.pag1 {
  width: 20%;
}
</style>
